{$ALIGN ON, $BOOLEVAL OFF, $LONGSTRINGS ON, $IOCHECKS ON, $WRITEABLECONST OFF}
{$OVERFLOWCHECKS OFF, $RANGECHECKS OFF, $TYPEDADDRESS ON, $MINENUMSIZE 1}
unit Main;

{ SFFView Version 1.02

  Copyright:
     2000, Peter J. Haas, Barleben, Germany

    Bitte License.txt lesen;  Please read License.txt

  Kontakt/Contact:
    EMail:     PeterJHaas@t-online.de,
    HomePage:  http://home.t-online.de/home/PeterJHaas/delphi.htm

  Beschreibung:
    Die Anwendung dient zur Demonstration der SFFRead-Unit.

  Description:
    The application is a demonstration of the SFFRead unit.

  History:
    Bitte Readme.txt lesen;  Please read Readme.txt
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, ExtDlgs, SFF;

type
  TViewMode = (vmSize, vmWidth, vm025, vm050, vm100);

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MPntFile: TMenuItem;
    MPntOpen: TMenuItem;
    MPntSaveAs: TMenuItem;
    N1: TMenuItem;
    MPntClose: TMenuItem;
    ImgSFF: TImage;
    MPntNextPage: TMenuItem;
    MPntPriorPage: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    MPntView: TMenuItem;
    MPntView100: TMenuItem;
    MPntViewSize: TMenuItem;
    MPntViewWidth: TMenuItem;
    MPntView050: TMenuItem;
    MPntView025: TMenuItem;
    N2: TMenuItem;
    procedure MPntCloseClick(Sender: TObject);
    procedure MPntOpenClick(Sender: TObject);
    procedure MPntNextPageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MPntPriorPageClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MPntSaveAsClick(Sender: TObject);
    procedure MPntViewChangeClick(Sender: TObject);
    procedure MPntViewClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FCurrentPage : Integer;     { aktuelle Seite (1..n); actual page (1..n) }
    FSFF         : TSFFFile;
    FViewMode    : TViewMode;   { Anzeigemodus; View-Mode }
  public
    { Public-Deklarationen }
    procedure ShowSFFGraphic;
  end;

var
  MainForm: TMainForm;

implementation
uses
  IniFiles;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FSFF:=TSFFFile.Create;
  with OpenPictureDialog1 do begin
    Filter:=GraphicFilter(TSFFGraphic);
    DefaultExt:=GraphicExtension(TSFFGraphic);
    Filename:=GraphicFileMask(TSFFGraphic);
    with TIniFile.Create(ChangeFileExt(Application.Exename,'.ini')) do try
      InitialDir:=ReadString('Directories','SFF-Dir','');
    finally
      Free;
    end;
  end;
  with SavePictureDialog1 do begin
    Filter:=GraphicFilter(TBitmap);
    DefaultExt:=GraphicExtension(TBitmap);
    Filename:=GraphicFileMask(TBitmap);
  end;
  FViewMode:=vm050;
  MPntViewSize .Tag:=Ord(vmSize );
  MPntViewWidth.Tag:=Ord(vmWidth);
  MPntView100  .Tag:=Ord(vm100  );
  MPntView050  .Tag:=Ord(vm050  );
  MPntView025  .Tag:=Ord(vm025  );
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FSFF.Free;
  FSFF:=Nil;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  ShowSFFGraphic;
end;

procedure TMainForm.ShowSFFGraphic;
var
  w, h : Integer;
  vx, vy : Extended;
begin
  if FSFF=Nil then Exit;
  if (FCurrentPage>0) and (FCurrentPage<=FSFF.PageCount) then begin
    if (FSFF.Graphics[FCurrentPage-1]<>Nil) then begin
      // Gre so anpassen, da die gesamte Seite auf das Formular pat
      // Making the page fit into the form
      with FSFF.Graphics[FCurrentPage-1] do begin
        case FViewMode of
          vmSize, vmWidth : begin
            vx:=ClientWidth  / Width ;
            vy:=ClientHeight / Height;
            if (vx<vy) or (FViewMode=vmWidth) then begin
              w:=Trunc(Width *vx);
              h:=Trunc(Height*vx);
            end
            else begin
              w:=Trunc(Width *vy);
              h:=Trunc(Height*vy);
            end;
          end;
          vm050 : begin
            w:=Width  div 2;
            h:=Height div 2;
          end;
          vm025 : begin
            w:=Width  div 4;
            h:=Height div 4;
          end;
        else
          w:=Width;
          h:=Height;
        end;
        ImgSFF.SetBounds(0,0,w,h);
      end;
    end;
    ImgSFF.Picture.Assign(FSFF.Graphics[FCurrentPage-1]);
  end;
end;

procedure TMainForm.MPntOpenClick(Sender: TObject);
begin
  FCurrentPage:=1;
  with OpenPictureDialog1 do begin
    if Execute then begin
      FSFF.Filename:=Filename;
      ShowSFFGraphic;
    end;
  end;
end;

procedure TMainForm.MPntPriorPageClick(Sender: TObject);
begin
  if FCurrentPage>1 then begin
    Dec(FCurrentPage);
    ShowSFFGraphic;
  end;
end;

procedure TMainForm.MPntNextPageClick(Sender: TObject);
begin
  if FCurrentPage<FSFF.PageCount then begin
    Inc(FCurrentPage);
    ShowSFFGraphic;
  end;
end;

procedure TMainForm.MPntCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.MPntSaveAsClick(Sender: TObject);
var
  b : TBitmap;
begin
  if (FCurrentPage>0) and (FCurrentPage<=FSFF.PageCount) and
     (FSFF.Graphics[FCurrentPage-1]<>Nil) then begin
    with SavePictureDialog1 do begin
      Filename:=Format('%sPage%d',[ChangeFileExt(FSFF.Filename,''),FCurrentPage]);
      if Execute then begin
        b:=TBitmap.Create;
        try
          b.Assign(FSFF.Graphics[FCurrentPage-1]);
          b.SaveToFile(Filename);
        finally
          b.Free;
        end;
      end;
    end;
  end;
end;

procedure TMainForm.MPntViewChangeClick(Sender: TObject);
begin
  FViewMode:=TViewMode((Sender as TMenuItem).Tag);
  ShowSFFGraphic;
end;

procedure TMainForm.MPntViewClick(Sender: TObject);
begin
  MPntViewSize .Checked:=FViewMode=vmSize ;
  MPntViewWidth.Checked:=FViewMode=vmWidth;
  MPntView100  .Checked:=FViewMode=vm100  ;
  MPntView050  .Checked:=FViewMode=vm050  ;
  MPntView025  .Checked:=FViewMode=vm025  ;
end;

end.
